//+------------------------------------------------------------------+ 
//|                                             Collector v1.00g.mq4 |
//+------------------------------------------------------------------+
//|                                             Collector v1.00g.mq4 |
//|                                               copyright 2006 DGC |
//+------------------------------------------------------------------+
/* Controlled exit points using Take Profit of minimum 20 points
*/
#property copyright "Copyright  2006 DGC"

extern int     TradeSpacing   = 10;
extern double  Lots           = 0.01;
extern int     mm             = 0;
extern int     MagicNumber    = 962245;

int ticket;
int      LONG                 = 2;
int      SHORT                = 1;
int      Target[3];
int      tgt;
int      OpenOrders           = 0;
int      cnt                  = 0;
int      slippage             = 3;
int      temp                 = 0;
double   lotsi                = 0;
double   mylotsi              = 0;
int      LastOrderType        = 0;
double   LastPrice            = 0;
int      PreviousOpenOrders   = 0;
string   CurrentBuild         = "v1.00g2";
double   TP                   = 0;

int init(){return(0);}
int deinit(){return(0);}

int start()
{
   int cnt = 0;

//1. Money management   
   if (mm != 0)
      lotsi = MathRound(AccountBalance() * 0.0002) / 100;
   else
      lotsi = Lots;

//2. Set Target array
   Target[0] = MathRound(20 * (TradeSpacing / 10));
   Target[1] = MathRound(20 * (TradeSpacing / 10));
   Target[2] = MathRound(13 * (TradeSpacing / 10));
   Target[3] = MathRound(14 * (TradeSpacing / 10));

//3. Get number of open orders   
   OpenOrders = 0;
   for(cnt = 0; cnt < OrdersTotal(); cnt ++)   
   {
     OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
	  if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
	  {				
	  	  OpenOrders ++;
	  }
   }     
//Alert (Symbol(), OpenOrders);
//4. Set new lotsize
   mylotsi = NormalizeDouble(lotsi * MathPow(2, OpenOrders), 2);
   if (mylotsi > 100) mylotsi = 100;

//5. Set target for next exit
   if(OpenOrders < 4)
      tgt = Target[OpenOrders];
   else
      tgt = MathRound(11 * (TradeSpacing / 10));

//6. Set values to most recent order placed
/*	  for(cnt = 0; cnt < OrdersTotal(); cnt ++)
	  {	
	    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
		 if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber) 
		 {
			LastPrice = OrderOpenPrice();
			if (OrderType() == OP_BUY)
			   LastOrderType = LONG;
			if (OrderType() == OP_SELL)
			   LastOrderType = SHORT;
		 }
	  }
*/
//7. If one order has closed, all orders will be closed   
   if (PreviousOpenOrders > OpenOrders) 
   {	  
      for(cnt = OrdersTotal() - 1; cnt >= 0; cnt --)
      {
         OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
         if ((OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)) 
            OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), slippage, Red);
      }
      PreviousOpenOrders = 0;
      OpenOrders = 0;
      LastOrderType = 0;
      mylotsi = Lots;
   }
   PreviousOpenOrders = OpenOrders;

//8. If needed, open initial trade
   if (OpenOrders < 1) 
   {   
      if(iCustom(NULL, 0, "i_Trend_s", 0, 0, 0, 30, 2, 20, 300, 0, 0) > 0)
      {
         TP = Ask + tgt * Point;
         LastOrderType = LONG;
         LastPrice = Ask;
//Alert(Symbol()," tgt:",tgt," TP:",TP);
         ticket = OrderSend(Symbol(), OP_BUY, mylotsi, Ask, slippage, 0, TP, NULL, MagicNumber, 0, White);
         OpenOrders ++;
      }
      else
      {
         TP = Bid - tgt * Point;
         LastOrderType = SHORT;
         LastPrice = Bid;
//Alert(Symbol()," tgt:",tgt," TP:",TP);
         ticket = OrderSend(Symbol(), OP_SELL, mylotsi, Bid, slippage, 0, TP, NULL, MagicNumber, 0, Red);
         OpenOrders ++;
      }
   }
   else
   {
   
//9. Place additional orders if appropriate
      if (LastOrderType == LONG) 
      {
         if ((LastPrice - Bid) >= TradeSpacing * Point) 
         {		
            TP = Bid - tgt * Point;
            LastOrderType = SHORT;
            LastPrice = Bid;
            OrderSend(Symbol(), OP_SELL, mylotsi, Bid, slippage, 0, TP, NULL, MagicNumber, 0, Red);
            OpenOrders ++;
         }
      }
      if (LastOrderType == SHORT) 
      {
         if ((Ask - LastPrice) >= TradeSpacing * Point) 
         {		
            TP = Ask + tgt * Point;
            LastOrderType = LONG;
            LastPrice = Ask;
            OrderSend(Symbol(), OP_BUY, mylotsi, Ask, slippage, 0, TP, NULL, MagicNumber, 0, White);
            OpenOrders ++;
         }
      }
   }
   Comment("Open orders = ", OpenOrders,
           "\nOrder type = ",LastOrderType,
           "\nLots = ",lotsi,
           "\nTarget = ",tgt,
           "\nBuild: ",CurrentBuild);
   return(0);
}

